################# Vallaris Maps ##################
############## By : sattawat arab ###############
###### GIS Backend Engineer #########
########### i-bitz company limited ##############
##################### 2020 ######################

import vallaris
import json
import os
import geopandas as gpd
def perform(storage, parameter):

    # get environ
    getEnviron = vallaris.setEnviron(parameter)
    # print(getEnviron)

    # get format
    format = vallaris.FormatValue(parameter)
    # print(format)

    # input
    input = vallaris.InputValue(storage, parameter)
    # print(input)

    # overlay
    # overlay = vallaris.OverlayValue(storage, parameter)
    # print(overlay)

    param = vallaris.ParamValue(parameter)[0]['value']
    # print(param)

    # process data
    try:
        layer_m = input.to_crs(epsg=32647)
        layer_m['geometry'] = layer_m.buffer(param)
        layer_lat = layer_m.to_crs(epsg=4326)
        process = "successful"
        log = ''

    except Exception as e:
        log = e
        process = "error"

    # send output
    if (process != "error"):
        msg = "EchoProcess job finished successful"
        data = layer_lat
        output = vallaris.ProcessSuccess(storage, parameter, msg, data)
    else:
        msg = "EchoProcess job failed : " + str(log)
        output = vallaris.ProcessFail(storage, parameter, msg)

    return output
